sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"installation","id":"Installation"},{"anchor":"hello-world","id":"Hello world"},{"anchor":"supervised-handlers","id":"Supervised handlers"},{"anchor":"supported-versions","id":"Supported Versions"},{"anchor":"the-plug-conn-struct","id":"The Plug.Conn struct"},{"anchor":"plug-router","id":"Plug.Router"},{"anchor":"testing-plugs","id":"Testing plugs"},{"anchor":"available-plugs","id":"Available plugs"},{"anchor":"helper-modules","id":"Helper modules"},{"anchor":"contributing","id":"Contributing"},{"anchor":"license","id":"License"}],"id":"readme","title":"Plug"},{"group":"Guides","headers":[{"anchor":"prerequisites","id":"Prerequisites"},{"anchor":"getting-started","id":"Getting Started"},{"anchor":"tls-protocol-options","id":"TLS Protocol Options"},{"anchor":"http-strict-transport-security-hsts","id":"HTTP Strict Transport Security (HSTS)"},{"anchor":"encrypted-keys","id":"Encrypted Keys"},{"anchor":"passing-der-binaries","id":"Passing DER Binaries"},{"anchor":"custom-diffie-hellman-parameters","id":"Custom Diffie-Hellman Parameters"},{"anchor":"renewing-certificates","id":"Renewing Certificates"},{"anchor":"listening-on-port-443","id":"Listening on Port 443"},{"anchor":"offloading-tls","id":"Offloading TLS"},{"anchor":"converting-certificates-and-keys","id":"Converting Certificates and Keys"}],"id":"https","title":"HTTPS"}],"modules":[{"group":"","id":"Plug","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:opts/0","id":"opts/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"forward/4","id":"forward/4"},{"anchor":"run/3","id":"run/3"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:call/2","id":"call/2"},{"anchor":"c:init/1","id":"init/1"}]}],"sections":[{"anchor":"module-examples","id":"Examples"},{"anchor":"module-the-plug-pipeline","id":"The Plug pipeline"}],"title":"Plug"},{"group":"","id":"Plug.Builder","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:plug/0","id":"plug/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"builder_opts/0","id":"builder_opts/0"},{"anchor":"compile/3","id":"compile/3"},{"anchor":"plug/2","id":"plug/2"}]}],"sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-plug-behaviour","id":"Plug behaviour"},{"anchor":"module-overriding-the-default-plug-api-functions","id":"Overriding the default Plug API functions"},{"anchor":"module-halting-a-plug-pipeline","id":"Halting a plug pipeline"}],"title":"Plug.Builder"},{"group":"","id":"Plug.Conn","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:adapter/0","id":"adapter/0"},{"anchor":"t:assigns/0","id":"assigns/0"},{"anchor":"t:before_send/0","id":"before_send/0"},{"anchor":"t:body/0","id":"body/0"},{"anchor":"t:cookies/0","id":"cookies/0"},{"anchor":"t:halted/0","id":"halted/0"},{"anchor":"t:headers/0","id":"headers/0"},{"anchor":"t:host/0","id":"host/0"},{"anchor":"t:int_status/0","id":"int_status/0"},{"anchor":"t:method/0","id":"method/0"},{"anchor":"t:owner/0","id":"owner/0"},{"anchor":"t:params/0","id":"params/0"},{"anchor":"t:port_number/0","id":"port_number/0"},{"anchor":"t:query_param/0","id":"query_param/0"},{"anchor":"t:query_params/0","id":"query_params/0"},{"anchor":"t:query_string/0","id":"query_string/0"},{"anchor":"t:req_cookies/0","id":"req_cookies/0"},{"anchor":"t:resp_cookies/0","id":"resp_cookies/0"},{"anchor":"t:scheme/0","id":"scheme/0"},{"anchor":"t:secret_key_base/0","id":"secret_key_base/0"},{"anchor":"t:segments/0","id":"segments/0"},{"anchor":"t:state/0","id":"state/0"},{"anchor":"t:status/0","id":"status/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"assign/3","id":"assign/3"},{"anchor":"chunk/2","id":"chunk/2"},{"anchor":"clear_session/1","id":"clear_session/1"},{"anchor":"configure_session/2","id":"configure_session/2"},{"anchor":"delete_req_header/2","id":"delete_req_header/2"},{"anchor":"delete_resp_cookie/3","id":"delete_resp_cookie/3"},{"anchor":"delete_resp_header/2","id":"delete_resp_header/2"},{"anchor":"delete_session/2","id":"delete_session/2"},{"anchor":"fetch_cookies/2","id":"fetch_cookies/2"},{"anchor":"fetch_query_params/2","id":"fetch_query_params/2"},{"anchor":"fetch_session/2","id":"fetch_session/2"},{"anchor":"get_http_protocol/1","id":"get_http_protocol/1"},{"anchor":"get_peer_data/1","id":"get_peer_data/1"},{"anchor":"get_req_header/2","id":"get_req_header/2"},{"anchor":"get_resp_header/2","id":"get_resp_header/2"},{"anchor":"get_session/1","id":"get_session/1"},{"anchor":"get_session/2","id":"get_session/2"},{"anchor":"halt/1","id":"halt/1"},{"anchor":"inform/3","id":"inform/3"},{"anchor":"inform!/3","id":"inform!/3"},{"anchor":"merge_assigns/2","id":"merge_assigns/2"},{"anchor":"merge_private/2","id":"merge_private/2"},{"anchor":"merge_resp_headers/2","id":"merge_resp_headers/2"},{"anchor":"prepend_resp_headers/2","id":"prepend_resp_headers/2"},{"anchor":"push/3","id":"push/3"},{"anchor":"push!/3","id":"push!/3"},{"anchor":"put_private/3","id":"put_private/3"},{"anchor":"put_req_header/3","id":"put_req_header/3"},{"anchor":"put_resp_content_type/3","id":"put_resp_content_type/3"},{"anchor":"put_resp_cookie/4","id":"put_resp_cookie/4"},{"anchor":"put_resp_header/3","id":"put_resp_header/3"},{"anchor":"put_session/3","id":"put_session/3"},{"anchor":"put_status/2","id":"put_status/2"},{"anchor":"read_body/2","id":"read_body/2"},{"anchor":"read_part_body/2","id":"read_part_body/2"},{"anchor":"read_part_headers/2","id":"read_part_headers/2"},{"anchor":"register_before_send/2","id":"register_before_send/2"},{"anchor":"request_url/1","id":"request_url/1"},{"anchor":"resp/3","id":"resp/3"},{"anchor":"send_chunked/2","id":"send_chunked/2"},{"anchor":"send_file/5","id":"send_file/5"},{"anchor":"send_resp/1","id":"send_resp/1"},{"anchor":"send_resp/3","id":"send_resp/3"},{"anchor":"update_req_header/4","id":"update_req_header/4"},{"anchor":"update_resp_header/4","id":"update_resp_header/4"}]}],"sections":[{"anchor":"module-request-fields","id":"Request fields"},{"anchor":"module-fetchable-fields","id":"Fetchable fields"},{"anchor":"module-response-fields","id":"Response fields"},{"anchor":"module-connection-fields","id":"Connection fields"},{"anchor":"module-private-fields","id":"Private fields"},{"anchor":"module-custom-status-codes","id":"Custom status codes"}],"title":"Plug.Conn"},{"group":"","id":"Plug.HTML","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"html_escape/1","id":"html_escape/1"},{"anchor":"html_escape_to_iodata/1","id":"html_escape_to_iodata/1"}]}],"sections":[],"title":"Plug.HTML"},{"group":"","id":"Plug.Router","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"delete/3","id":"delete/3"},{"anchor":"forward/2","id":"forward/2"},{"anchor":"get/3","id":"get/3"},{"anchor":"head/3","id":"head/3"},{"anchor":"match/3","id":"match/3"},{"anchor":"match_path/1","id":"match_path/1"},{"anchor":"options/3","id":"options/3"},{"anchor":"patch/3","id":"patch/3"},{"anchor":"post/3","id":"post/3"},{"anchor":"put/3","id":"put/3"}]}],"sections":[{"anchor":"module-routes","id":"Routes"},{"anchor":"module-parameter-parsing","id":"Parameter Parsing"},{"anchor":"module-error-handling","id":"Error handling"},{"anchor":"module-passing-data-between-routes-and-plugs","id":"Passing data between routes and plugs"},{"anchor":"module-routes-compilation","id":"Routes compilation"},{"anchor":"module-routes-options","id":"Routes options"},{"anchor":"module-telemetry","id":"Telemetry"}],"title":"Plug.Router"},{"group":"","id":"Plug.Test","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"conn/3","id":"conn/3"},{"anchor":"delete_req_cookie/2","id":"delete_req_cookie/2"},{"anchor":"init_test_session/2","id":"init_test_session/2"},{"anchor":"put_http_protocol/2","id":"put_http_protocol/2"},{"anchor":"put_peer_data/2","id":"put_peer_data/2"},{"anchor":"put_req_cookie/3","id":"put_req_cookie/3"},{"anchor":"recycle_cookies/2","id":"recycle_cookies/2"},{"anchor":"sent_informs/1","id":"sent_informs/1"},{"anchor":"sent_pushes/1","id":"sent_pushes/1"},{"anchor":"sent_resp/1","id":"sent_resp/1"}]}],"sections":[],"title":"Plug.Test"},{"group":"","id":"Plug.Upload","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"child_spec/1","id":"child_spec/1"},{"anchor":"give_away/3","id":"give_away/3"},{"anchor":"random_file/1","id":"random_file/1"},{"anchor":"random_file!/1","id":"random_file!/1"}]}],"sections":[{"anchor":"module-security","id":"Security"}],"title":"Plug.Upload"},{"group":"Plugs","id":"Plug.BasicAuth","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"basic_auth/2","id":"basic_auth/2"},{"anchor":"encode_basic_auth/2","id":"encode_basic_auth/2"},{"anchor":"parse_basic_auth/1","id":"parse_basic_auth/1"},{"anchor":"request_basic_auth/2","id":"request_basic_auth/2"}]}],"sections":[{"anchor":"module-compile-time-usage","id":"Compile-time usage"},{"anchor":"module-runtime-time-usage","id":"Runtime-time usage"},{"anchor":"module-low-level-usage","id":"Low-level usage"}],"title":"Plug.BasicAuth"},{"group":"Plugs","id":"Plug.CSRFProtection","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"delete_csrf_token/0","id":"delete_csrf_token/0"},{"anchor":"dump_state/0","id":"dump_state/0"},{"anchor":"dump_state_from_session/1","id":"dump_state_from_session/1"},{"anchor":"get_csrf_token/0","id":"get_csrf_token/0"},{"anchor":"get_csrf_token_for/1","id":"get_csrf_token_for/1"},{"anchor":"load_state/2","id":"load_state/2"},{"anchor":"valid_state_and_csrf_token?/2","id":"valid_state_and_csrf_token?/2"}]}],"sections":[{"anchor":"module-token-generation","id":"Token generation"},{"anchor":"module-cross-host-protection","id":"Cross-host protection"},{"anchor":"module-options","id":"Options"},{"anchor":"module-disabling","id":"Disabling"},{"anchor":"module-examples","id":"Examples"}],"title":"Plug.CSRFProtection"},{"group":"Plugs","id":"Plug.Head","sections":[{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Head"},{"group":"Plugs","id":"Plug.Logger","sections":[{"anchor":"module-options","id":"Options"}],"title":"Plug.Logger"},{"group":"Plugs","id":"Plug.MethodOverride","sections":[{"anchor":"module-examples","id":"Examples"}],"title":"Plug.MethodOverride"},{"group":"Plugs","id":"Plug.Parsers","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:init/1","id":"init/1"},{"anchor":"c:parse/5","id":"parse/5"}]}],"sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-examples","id":"Examples"},{"anchor":"module-built-in-parsers","id":"Built-in parsers"},{"anchor":"module-file-handling","id":"File handling"},{"anchor":"module-custom-body-reader","id":"Custom body reader"}],"title":"Plug.Parsers"},{"group":"Plugs","id":"Plug.RequestId","sections":[{"anchor":"module-options","id":"Options"}],"title":"Plug.RequestId"},{"group":"Plugs","id":"Plug.RewriteOn","sections":[],"title":"Plug.RewriteOn"},{"group":"Plugs","id":"Plug.SSL","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"configure/1","id":"configure/1"}]}],"sections":[{"anchor":"module-x-forwarded","id":"x-forwarded-*"},{"anchor":"module-plug-options","id":"Plug Options"},{"anchor":"module-port","id":"Port"},{"anchor":"module-excluded-hosts-tuple","id":"Excluded hosts tuple"}],"title":"Plug.SSL"},{"group":"Plugs","id":"Plug.Session","sections":[{"anchor":"module-session-stores","id":"Session stores"},{"anchor":"module-options","id":"Options"},{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Session"},{"group":"Plugs","id":"Plug.Static","sections":[{"anchor":"module-cache-mechanisms","id":"Cache mechanisms"},{"anchor":"module-options","id":"Options"},{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Static"},{"group":"Plugs","id":"Plug.Telemetry","sections":[{"anchor":"module-time-unit","id":"Time unit"},{"anchor":"module-example","id":"Example"}],"title":"Plug.Telemetry"},{"group":"Error handling","id":"Plug.Debugger","sections":[{"anchor":"module-examples","id":"Examples"},{"anchor":"module-options","id":"Options"},{"anchor":"module-custom-styles","id":"Custom styles"},{"anchor":"module-custom-banners","id":"Custom Banners"},{"anchor":"module-links-to-the-text-editor","id":"Links to the text editor"}],"title":"Plug.Debugger"},{"group":"Error handling","id":"Plug.ErrorHandler","sections":[],"title":"Plug.ErrorHandler"},{"group":"Error handling","id":"Plug.Exception","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:action/0","id":"action/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"actions/1","id":"actions/1"},{"anchor":"status/1","id":"status/1"}]}],"sections":[],"title":"Plug.Exception"},{"group":"Plug.Conn","id":"Plug.Conn.Adapter","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:http_protocol/0","id":"http_protocol/0"},{"anchor":"t:payload/0","id":"payload/0"},{"anchor":"t:peer_data/0","id":"peer_data/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:chunk/2","id":"chunk/2"},{"anchor":"c:get_http_protocol/1","id":"get_http_protocol/1"},{"anchor":"c:get_peer_data/1","id":"get_peer_data/1"},{"anchor":"c:inform/3","id":"inform/3"},{"anchor":"c:push/3","id":"push/3"},{"anchor":"c:read_req_body/2","id":"read_req_body/2"},{"anchor":"c:send_chunked/3","id":"send_chunked/3"},{"anchor":"c:send_file/6","id":"send_file/6"},{"anchor":"c:send_resp/4","id":"send_resp/4"}]}],"sections":[],"title":"Plug.Conn.Adapter"},{"group":"Plug.Conn","id":"Plug.Conn.Cookies","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/1","id":"decode/1"},{"anchor":"encode/2","id":"encode/2"}]}],"sections":[],"title":"Plug.Conn.Cookies"},{"group":"Plug.Conn","id":"Plug.Conn.Query","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/4","id":"decode/4"},{"anchor":"decode_pair/2","id":"decode_pair/2"},{"anchor":"encode/2","id":"encode/2"}]}],"sections":[],"title":"Plug.Conn.Query"},{"group":"Plug.Conn","id":"Plug.Conn.Status","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"code/1","id":"code/1"},{"anchor":"reason_atom/1","id":"reason_atom/1"},{"anchor":"reason_phrase/1","id":"reason_phrase/1"}]}],"sections":[],"title":"Plug.Conn.Status"},{"group":"Plug.Conn","id":"Plug.Conn.Unfetched","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"fetch/2","id":"fetch/2"},{"anchor":"get/3","id":"get/3"},{"anchor":"get_and_update/3","id":"get_and_update/3"},{"anchor":"pop/2","id":"pop/2"}]}],"sections":[{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Conn.Unfetched"},{"group":"Plug.Conn","id":"Plug.Conn.Utils","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:params/0","id":"params/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"content_type/1","id":"content_type/1"},{"anchor":"list/1","id":"list/1"},{"anchor":"media_type/1","id":"media_type/1"},{"anchor":"params/1","id":"params/1"},{"anchor":"token/1","id":"token/1"},{"anchor":"validate_utf8!/3","id":"validate_utf8!/3"}]}],"sections":[],"title":"Plug.Conn.Utils"},{"group":"Plug.Parsers","id":"Plug.Parsers.JSON","sections":[{"anchor":"module-options","id":"Options"}],"title":"Plug.Parsers.JSON"},{"group":"Plug.Parsers","id":"Plug.Parsers.MULTIPART","sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-dynamic-configuration","id":"Dynamic configuration"}],"title":"Plug.Parsers.MULTIPART"},{"group":"Plug.Parsers","id":"Plug.Parsers.URLENCODED","sections":[{"anchor":"module-options","id":"Options"}],"title":"Plug.Parsers.URLENCODED"},{"group":"Plug.Session","id":"Plug.Session.COOKIE","sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Session.COOKIE"},{"group":"Plug.Session","id":"Plug.Session.ETS","sections":[{"anchor":"module-options","id":"Options"},{"anchor":"module-storage","id":"Storage"},{"anchor":"module-examples","id":"Examples"}],"title":"Plug.Session.ETS"},{"group":"Plug.Session","id":"Plug.Session.Store","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:cookie/0","id":"cookie/0"},{"anchor":"t:session/0","id":"session/0"},{"anchor":"t:sid/0","id":"sid/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"get/1","id":"get/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:delete/3","id":"delete/3"},{"anchor":"c:get/3","id":"get/3"},{"anchor":"c:init/1","id":"init/1"},{"anchor":"c:put/4","id":"put/4"}]}],"sections":[],"title":"Plug.Session.Store"},{"group":"Exceptions","id":"Plug.BadRequestError","sections":[],"title":"Plug.BadRequestError"},{"group":"Exceptions","id":"Plug.CSRFProtection.InvalidCSRFTokenError","sections":[],"title":"Plug.CSRFProtection.InvalidCSRFTokenError"},{"group":"Exceptions","id":"Plug.CSRFProtection.InvalidCrossOriginRequestError","sections":[],"title":"Plug.CSRFProtection.InvalidCrossOriginRequestError"},{"group":"Exceptions","id":"Plug.Conn.AlreadySentError","sections":[],"title":"Plug.Conn.AlreadySentError"},{"group":"Exceptions","id":"Plug.Conn.CookieOverflowError","sections":[],"title":"Plug.Conn.CookieOverflowError"},{"group":"Exceptions","id":"Plug.Conn.InvalidHeaderError","sections":[],"title":"Plug.Conn.InvalidHeaderError"},{"group":"Exceptions","id":"Plug.Conn.InvalidQueryError","sections":[],"title":"Plug.Conn.InvalidQueryError"},{"group":"Exceptions","id":"Plug.Conn.NotSentError","sections":[],"title":"Plug.Conn.NotSentError"},{"group":"Exceptions","id":"Plug.Conn.WrapperError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"},{"anchor":"reraise/1","id":"reraise/1"},{"anchor":"reraise/3","id":"reraise/3"},{"anchor":"reraise/4","id":"reraise/4"}]}],"sections":[],"title":"Plug.Conn.WrapperError"},{"group":"Exceptions","id":"Plug.Parsers.BadEncodingError","sections":[],"title":"Plug.Parsers.BadEncodingError"},{"group":"Exceptions","id":"Plug.Parsers.ParseError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Plug.Parsers.ParseError"},{"group":"Exceptions","id":"Plug.Parsers.RequestTooLargeError","sections":[],"title":"Plug.Parsers.RequestTooLargeError"},{"group":"Exceptions","id":"Plug.Parsers.UnsupportedMediaTypeError","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"message/1","id":"message/1"}]}],"sections":[],"title":"Plug.Parsers.UnsupportedMediaTypeError"},{"group":"Exceptions","id":"Plug.Router.InvalidSpecError","sections":[],"title":"Plug.Router.InvalidSpecError"},{"group":"Exceptions","id":"Plug.Router.MalformedURIError","sections":[],"title":"Plug.Router.MalformedURIError"},{"group":"Exceptions","id":"Plug.Static.InvalidPathError","sections":[],"title":"Plug.Static.InvalidPathError"},{"group":"Exceptions","id":"Plug.TimeoutError","sections":[],"title":"Plug.TimeoutError"},{"group":"Exceptions","id":"Plug.UploadError","sections":[],"title":"Plug.UploadError"}],"tasks":[]}